//+------------------------------------------------------------------+
//|                                                       vic013.mq4 |
//|                                                        avoitenko |
//|                        https://login.mql5.com/en/users/avoitenko |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "https://login.mql5.com/en/users/avoitenko"

//+------------------------------------------------------------------+
//|                                                         |
//+------------------------------------------------------------------+
#define ExpertName    "Game2" //  
#define ExpertVersion "1.0"       // .

#define ARRAY_COUNT    8

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
extern string trade_stop        = "   , 0 - ";
extern int    TRADE_STOP_PLUS   =    1; 
extern int    TRADE_STOP_MINUS  =    3;
//---
extern string start_trade       = " : 0 -  , 1 - RSI, 2 - DeMarker";
extern int    TRADE_VARIANT     =    0;
extern string ind_period        = "  0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200";
extern int    TIMEFRAME         =    0; // 
extern int    IND_PERIOD        =   70; //  
//---
extern bool   LOT_IS_FIXED      = true; //  
extern double LOT_FIXED         =  0.1; //  -  
extern double LOT_PERCENT       =    1; //  - %  
//---
extern int    TP_VIRTUAL        =  100; //   
extern int    SL_VIRTUAL        =   80; //   
//---
extern int    TAKE_PROFIT       =  200; //  
extern int    STOP_LOSS         =  200; //  
//---
extern bool   USE_TRAILING_STOP = false; // Trailing stop
extern int    TRAILING_STOP     =   50; // Trailing stop level
extern int    TRAILING_STEP     =    1; // Trailing step 
//---
extern bool   MARKET_EXECUTION  = true;
extern int    SLIPPAGE          =    2; // 
extern int    MAGIC_NUMBER      = 3321; //   

//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+

datetime time_hour;

bool buy_open=false;
bool sell_open=false;

bool signals;
bool close_all;

string order_comment;
string err_msg;
int coef;
int sell_pos=0, buy_pos=0;

bool start;
int periods[10] = {0, PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   start=true;
   
   //+------------------------------------------------------------------+
   //|                                             |
   //+------------------------------------------------------------------+
   if(TRADE_STOP_PLUS<0)
   {
      err_msg = ",    TRADE_STOP_PLUS = " + DoubleToStr(TRADE_STOP_PLUS, 0) + ",  : >=0";
      start = false;
   }
//---
   if(TRADE_STOP_MINUS<0)
   {
      err_msg = ",    TRADE_STOP_MINUS = " + DoubleToStr(TRADE_STOP_MINUS, 0) + ",  : >=0";
      start = false;
   }

//----
   if(TRADE_VARIANT<0 || TRADE_VARIANT>2)
   {
      err_msg = ",    TRADE_VARIANT = " + DoubleToStr(TRADE_VARIANT, 0) + ",  : 0 - 2";
      start = false;
   }

//---
   if(IND_PERIOD<3)
   {
      err_msg = ",    IND_PERIOD = " + DoubleToStr(IND_PERIOD, 0) + ",  : >=3";
      start = false;
   }
//---   
   bool check = false;
   if(TIMEFRAME==0)TIMEFRAME = Period();
   for(int i=0; i<ArraySize(periods); i++)
   {
      if(periods[i] == TIMEFRAME){check = true; break;}
   }
   if(!check)
   {
      err_msg = ",    TIMEFRAME = " + DoubleToStr(TIMEFRAME, 0) + ",  : 0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200";
      start = false;
   }
   if(!check)
   {
      err_msg = ",    TIMEFRAME = " + DoubleToStr(TIMEFRAME, 0) + ",  : 0, 1, 5, 15, 30, 60, 240, 1440, 10080, 43200";
      start = false;
   }

//----
   if(TP_VIRTUAL<0)
   {
      err_msg = ",    TP_VIRTUAL = " + DoubleToStr(TP_VIRTUAL, 0) + ",  : >=0";
      start = false;
   }

//----
   if(SL_VIRTUAL<0)
   {
      err_msg = ",    SL_VIRTUAL = " + DoubleToStr(SL_VIRTUAL, 0) + ",  : >=0";
      start = false;
   }

//----
   if(TAKE_PROFIT<0)
   {
      err_msg = ",    TAKE_PROFIT = " + DoubleToStr(TAKE_PROFIT, 0) + ",  : >=0";
      start = false;
   }

//----
   if(STOP_LOSS<0)
   {
      err_msg = ",    STOP_LOSS = " + DoubleToStr(STOP_LOSS, 0) + ",  : >=0";
      start = false;
   }

   if(USE_TRAILING_STOP)
   {   

//----
      if(TRAILING_STOP < 0)
      {
         err_msg = ",    TRAILING_STOP = " + DoubleToStr(TRAILING_STOP,0) + ",  : >= 0";
         start = false;
      }

//----
      if(TRAILING_STEP < 1)
      {
         err_msg = ",    TRAILING_STEP = " + DoubleToStr(TRAILING_STEP,0) + ",  : >= 1";
         start = false;
      }

//----
      if(TRAILING_STEP > TRAILING_STOP)
      {
         err_msg = ",    TRAILING_STOP = " + DoubleToStr(TRAILING_STOP,0) + ",  : >= TRAILING_STEP(" + DoubleToStr(TRAILING_STEP,0) +")";
         start = false;
      }
   }

//----
   if(SLIPPAGE<0)
   {
      err_msg = ",    SLIPPAGE = " + DoubleToStr(SLIPPAGE, 0) + ",  : >=0";
      start = false;
   }

   order_comment = ExpertName + " v" + ExpertVersion;
   
   coef = 1;
//--- If the price includes 3/5 decimal places
   if(Digits == 3 || Digits == 5) coef = 10;

   if(!start)
   {
      Print(err_msg);
      Comment("\n" + err_msg);
   }
   else
      Print(" " + order_comment + "   .");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   if(start) Print(" " + order_comment + "  .");
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
   //---   ,  
   if(!start)return(0);
   
   //---     
   if(!IsTradeAllowed() && !IsTesting())
   {
      err_msg = "   .   .";
      Comment(err_msg);
      return;
   }

   
   
   if(close_all)
   {
      if(ClosePositions(MAGIC_NUMBER))return(0);
      close_all=false;
   }
   
   buy_open=false;
   sell_open=false;
   
   if(signals)
   {
      //---  
      switch(TRADE_VARIANT)
      {
         case 0://---    
         {
            double open1  = iOpen(Symbol(),PERIOD_D1,1);
            double close1 = iClose(Symbol(),PERIOD_D1,1);
            if(open1 == 0.0 || close1 == 0.0){Print(" "); return(0);}
      
            if(open1 < close1) buy_open=true;
            else sell_open=true;
            break;
         }
         case 1://---   RSI
         {
            double rsi = NormalizeDouble(iRSI(NULL,TIMEFRAME,IND_PERIOD,PRICE_CLOSE,1),2);
            if(rsi > 50) buy_open = true;
            else sell_open = true;
            break;      
         }
         case 2://---   DeMarker
         {
            double demarker = NormalizeDouble(iDeMarker(NULL,TIMEFRAME,IND_PERIOD,1),2);
            if(demarker > 50) buy_open = true;
            else sell_open = true;
            break;      
         }
      }
   }

   WorkWithPositions();

//----
   if((buy_pos + sell_pos)==0)
   {
      if(time_hour != iTime(Symbol(),PERIOD_H1,1))
      {
         //---           
         if(!CalcStatistic(signals,MAGIC_NUMBER))return(0); 
         time_hour = iTime(Symbol(),PERIOD_H1,1);
      }
   }

   return(0);
  }
//+------------------------------------------------------------------+
void WorkWithPositions()
//+------------------------------------------------------------------+
{
   double sl,tp;
   int stop_level = MarketInfo( Symbol(), MODE_STOPLEVEL);
   double ask = NormalizeDouble(Ask, Digits);
   double bid = NormalizeDouble(Bid, Digits);
   buy_pos = 0;
   sell_pos = 0;
   int orders_total = OrdersTotal();
   for(int i = orders_total-1; i>=0; i--)
   {
      
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         Print( "Error function OrderSelect(): ", GetLastError()); 
         Sleep(1000);
         return(0);
      }
      
      if (OrderType() > OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != MAGIC_NUMBER ) continue; // not my order

      double order_take_profit = NormalizeDouble(OrderTakeProfit(), Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(), Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);

      //+----------------------------------+
      //|   Processing open positions SELL |
      //+----------------------------------+ 
      if (OrderType() == OP_SELL) 
      {
         sell_pos++;

            //--------------------------------+
            //|  Virtual SL  TP for SELL     |
            //--------------------------------+
            sl = NormalizeDouble(order_open_price + SL_VIRTUAL*coef*Point,Digits);
            tp = NormalizeDouble(order_open_price - TP_VIRTUAL*coef*Point,Digits);
            
            if((SL_VIRTUAL && ask>=sl) || (TP_VIRTUAL && ask<=tp)) {close_all=true; return(0);}
         
            //--------------------------------+
            //|  Setup SL  TP for SELL       |
            //--------------------------------+
            if(MARKET_EXECUTION)
            {
               if((order_stop_loss==0.0 && STOP_LOSS!=0)||(order_take_profit == 0.0 && TAKE_PROFIT !=0))
               {
                  if(STOP_LOSS == 0) double new_sl = 0.0;
                  else new_sl = NormalizeDouble(MathMax(order_open_price + MathMax(STOP_LOSS*coef,stop_level) * Point, Ask + stop_level * Point), Digits);
                  
                  if(TAKE_PROFIT == 0) double new_tp = 0.0;
                  else new_tp = NormalizeDouble(MathMin(order_open_price - MathMax(TAKE_PROFIT*coef,stop_level) * Point, Ask - stop_level * Point), Digits);
               
                  if (OrderModify(OrderTicket(), order_open_price, new_sl, new_tp, OrderExpiration()))
                     Print("Setup sl and tp order #", OrderTicket());  
                  else
                     Print("Error setup sl and tp order #", OrderTicket(),". Error code: ",GetLastError());
               }
            }

         //+----------------------------------+
         //|   Classic Trailing Stop for SELL |
         //+----------------------------------+
         if(USE_TRAILING_STOP && TRAILING_STOP > 0)
         {
            //--- check for enable using ts 

            double target = NormalizeDouble(order_open_price - TRAILING_STOP * coef * Point, Digits);
      
            if(ask < target)
            {
               //--- work with trailing stop
               if(order_stop_loss > order_open_price || order_stop_loss == 0)
                  target = NormalizeDouble(order_open_price - MathMax(TRAILING_STOP*coef, stop_level) * Point, Digits);
               else
                  target = NormalizeDouble(order_stop_loss - TRAILING_STEP * coef * Point - MathMax(TRAILING_STOP*coef, stop_level) * Point, Digits);

               //---
               if(ask < target)
               {
                  if (order_stop_loss > order_open_price || order_stop_loss == 0) 
                  {
                     if (OrderModify(OrderTicket(), order_open_price, order_open_price, OrderTakeProfit(),0))
                        Print("Modified stop loss order #", OrderTicket());  
                     else
                        Print("Error modify the stop loss order0 #", OrderTicket(),".  : ",GetLastError());
                  }
                  else
                  {
                     if (OrderModify(OrderTicket(),order_open_price, NormalizeDouble(order_stop_loss - TRAILING_STEP*coef*Point,Digits),OrderTakeProfit(),0))
                        Print("Modified stop loss order #", OrderTicket());  
                     else
                        Print("Error modify the stop loss order1 #",OrderTicket(),".  : ",GetLastError());
                  }// end if  
               }

            }//end if

         }// end TRAILING_STOP 
      
      }// end OP_SELL   

      if(OrderType() == OP_BUY) 
      {
         buy_pos++;
         
            //--------------------------------+
            //|  Virtual SL  TP for BUY      |
            //--------------------------------+
            sl = NormalizeDouble(order_open_price - SL_VIRTUAL*coef*Point,Digits);
            tp = NormalizeDouble(order_open_price + TP_VIRTUAL*coef*Point,Digits);
            
            if(bid<=sl || bid >=tp) {close_all=true; return(0);}
         
            //--------------------------------+
            //|  Setup SL  TP for BUY        |
            //--------------------------------+

            if(MARKET_EXECUTION)
            {
               if((order_stop_loss == 0.0 && STOP_LOSS!=0)||(order_take_profit == 0.0 && TAKE_PROFIT !=0))
               {
                  if(STOP_LOSS == 0) new_sl = 0.0;
                  else new_sl = NormalizeDouble(MathMin(order_open_price - MathMax(STOP_LOSS*coef,stop_level) * Point, Bid - stop_level * Point), Digits);
                  
                  if(TAKE_PROFIT == 0) new_tp = 0.0;
                  else new_tp = NormalizeDouble(MathMax(order_open_price + MathMax(TAKE_PROFIT*coef,stop_level) * Point, Bid + stop_level * Point), Digits);
               
                  if (OrderModify(OrderTicket(), order_open_price, new_sl, new_tp, OrderExpiration()))
                     Print("Setup sl and tp order #", OrderTicket());  
                  else
                     Print("Error setup sl and tp order#", OrderTicket(),". Error code: ",GetLastError());
               }
            }

         
         if(USE_TRAILING_STOP && TRAILING_STOP > 0)
         {
            //--- check enable ts
         
            target = NormalizeDouble(order_open_price + TRAILING_STOP*coef * Point, Digits);
      
            if(bid > target)
            {
               //--- work with trailing stop
               if(order_stop_loss < order_open_price || order_stop_loss == 0)
                  target = NormalizeDouble(order_open_price + MathMax(TRAILING_STOP*coef, stop_level)*Point, Digits);
               else
                  target = NormalizeDouble(order_stop_loss + TRAILING_STEP*coef*Point + MathMax(TRAILING_STOP*coef, stop_level)*Point, Digits);

               //---
               if(bid > target)
               {
                  if (order_stop_loss < order_open_price || order_stop_loss == 0) 
                  {
                     if (OrderModify(OrderTicket(), order_open_price, order_open_price, OrderTakeProfit(),OrderExpiration()))
                        Print("Modified stop loss order #", OrderTicket());  
                     else
                        Print("Error modify the stop loss order2 #", OrderTicket(),". Error code: ",GetLastError());
                  }
                  else
                  {
                     if (OrderModify(OrderTicket(),order_open_price, NormalizeDouble(order_stop_loss + TRAILING_STEP*coef*Point,Digits),OrderTakeProfit(),OrderExpiration()))
                        Print("odified stop loss order #", OrderTicket());  
                     else
                        Print("Error modify the stop loss order3  #",OrderTicket(),". Error code: ",GetLastError());
                  }
               }  
            }
         }// end TRAILING_STOP
         
      }// end BUY
      
   }// end for

   //--- open positions
   if(sell_open && (sell_pos+buy_pos)==0)
   {
      if(OpenSellPosition(STOP_LOSS, TAKE_PROFIT, MathAbs(LOT_FIXED), MAGIC_NUMBER)){signals=false; return;}
   }

   //---   
   if(buy_open && (buy_pos+sell_pos)==0)
   {
      if(OpenBuyPosition(STOP_LOSS, TAKE_PROFIT, 0, MAGIC_NUMBER)){signals=false; return;}
   }
   
}// end Trade_SELL
//+------------------------------------------------------------------+
bool OpenSellPosition(int stop_loss,int take_profit,double lot_value, int magic)
//+------------------------------------------------------------------+
{

   double sl,tp;
   //--- check lot value
   double lot = NormalizeLot();

   //--- check free margin
   if( AccountFreeMarginCheck(Symbol(),OP_SELL, lot) <= 0 || GetLastError() == 134 )
   {
      Print("    ");
      return(false);
   }

   //---
   int stop_level = MarketInfo( Symbol(), MODE_STOPLEVEL);

   double price = NormalizeDouble(Bid, Digits);
   
   if(stop_loss == 0) sl=0.0;
   else sl = NormalizeDouble(MathMax(Bid + stop_loss * coef * Point, Ask + stop_level * Point), Digits);

   if(take_profit == 0) tp=0.0;
   else tp = NormalizeDouble(MathMin(Bid - take_profit * coef * Point, Ask - stop_level * Point), Digits);

   if(MARKET_EXECUTION) {sl=0.0; tp=0.0;}

   int ticket = OrderSend(Symbol(), OP_SELL, lot, price, SLIPPAGE * coef, sl, tp, order_comment, magic, 0);
   if(ticket > 0)
   {
      Print("Position opened #", ticket);
      sell_open = false;
      SetArrow(OP_SELL, Bid,0);
      return(true); //position opened
   }
   else
   {
      int Error = GetLastError(); //Error

      switch(Error)
      {
         case 138: Print("Error: ",Error," New prices.");break;
         case 135: Print("Error: ",Error," Price changed.");break;
         case 136: Print("No price."); break;
         case 146: Print("The subsystem is busy trade.");break;
         default:  Print("Error ", Error," Output from subroutine.");break;
      }// end switch
   
      Sleep(1000);
      RefreshRates();
   }// end else
      
   return(false);
}

//+------------------------------------------------------------------+
bool OpenBuyPosition(int stop_loss, int take_profit, double lot_value, int magic)
//+------------------------------------------------------------------+
{
   double sl,tp;
   
   //--- check lot value
   double lot = NormalizeLot();

   //--- check free margin
   if( AccountFreeMarginCheck(Symbol(),OP_SELL, lot) <= 0 || GetLastError() == 134 )
   {
      Print("Not enough free margin for opening position (buy)");
      return(false);
   }

   //---
   int stop_level = MarketInfo( Symbol(), MODE_STOPLEVEL);

   double price = NormalizeDouble(Ask, Digits);

   if(stop_loss == 0) sl=0.0;
   else sl = NormalizeDouble(MathMin(Ask - stop_loss * coef * Point, Bid - stop_level * Point), Digits);
   
   if(take_profit == 0) tp=0.0;
   else tp = NormalizeDouble(MathMax(Ask + take_profit * coef * Point, Bid + stop_level * Point), Digits);

   if(MARKET_EXECUTION) {sl=0.0; tp=0.0;}
   
   int ticket = OrderSend(Symbol(), OP_BUY, lot, price, SLIPPAGE*coef, sl, tp, order_comment, magic, 0);
   if( ticket > 0)
   {
      Print("Position opened #", ticket);
      buy_open = false;
      SetArrow(OP_BUY, Ask,0);
      return(true); // position opened
   }
   else
   {
      int Error = GetLastError(); //Error

      switch(Error)
      {
         case 138: Print("Error: ",Error," New prices.");break;
         case 135: Print("Error: ",Error," Price changed.");break;
         case 136: Print("No price."); break;
         case 146: Print("The subsystem is busy trade.");break;
         default:  Print("Error ", Error," Output from subroutine.");break;
      }// end switch

      Sleep(1000);
      RefreshRates();
   }// end else
      
   return(false);

}

//+------------------------------------------------------------------+
double NormalizeLot()
//+------------------------------------------------------------------+
{
   double lot_size = MarketInfo(Symbol(), MODE_LOTSIZE);
   double lot_min  = MarketInfo(Symbol(), MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(), MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(), MODE_LOTSTEP);
   double lot_one  = MarketInfo(Symbol(), MODE_MARGINREQUIRED);

   if(LOT_IS_FIXED)
      double lot_value = MathAbs(LOT_FIXED);
   else 
      lot_value = MathFloor((lot_size/100000)*AccountFreeMargin()*LOT_PERCENT/100/lot_one/lot_step)*lot_step;
   

        if(lot_value <= lot_min) lot_value = lot_min;           // checking for minimum lot
   else if(lot_value >= lot_max) lot_value = lot_max;           // checking the maximum lot
   else    lot_value  = MathFloor(lot_value/lot_step)*lot_step; // rounding to the nearest

   return (NormalizeDouble(lot_value,2)); // normalization
}

//+------------------------------------------------------------------+
void SetArrow(int order_type, double price, int index_time)
//+------------------------------------------------------------------+
{
   string name = StringConcatenate("Arrow ",Time[index_time]);
   if  ( order_type == OP_BUY ) 
   {
      if(ObjectCreate( name, OBJ_ARROW, 0, Time[index_time], price))
      {
         ObjectSet(name, OBJPROP_ARROWCODE, 159);
         ObjectSet(name, OBJPROP_COLOR, Blue);
         ObjectSet(name, OBJPROP_WIDTH, 2);
      }
   }
   else if ( order_type == OP_SELL) 
   {
      if(ObjectCreate(name, OBJ_ARROW, 0, Time[index_time], price))
      {
         ObjectSet(name, OBJPROP_ARROWCODE, 159);
         ObjectSet(name, OBJPROP_COLOR, Red);
         ObjectSet(name, OBJPROP_WIDTH, 2);
      }
   }
   WindowRedraw(); 
}

//+------------------------------------------------------------------+
bool ClosePositions(int magic)
//+------------------------------------------------------------------+
{
   bool res = false;
   int orders_total = OrdersTotal();
   for(int i=orders_total-1; i>=0; i--) 
   {
      if(OrderSelect(i,SELECT_BY_POS, MODE_TRADES))
      {
         if(OrderType() > OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != magic ) continue; //not my order
         
         res = true;

              if(OrderType() ==  OP_BUY) double price = NormalizeDouble(Bid,Digits);
         else if(OrderType() == OP_SELL) price = NormalizeDouble(Ask,Digits);
         else return(res);
         
         if(OrderClose(OrderTicket(),OrderLots(),price,SLIPPAGE*coef,Blue))
            Print("Position closed #",OrderTicket());
         else
            Print("Error, position not closed #",OrderTicket());
      }
   }// end for
   return(res);
}

//+------------------------------------------------------------------+
bool CalcStatistic(bool &trade, int magic)
//+------------------------------------------------------------------+
{
   trade=true;
   
   int pos_plus=0;
   int pos_minus = 0;
   int orders_total = OrdersHistoryTotal();

   for(int i=orders_total-1; i>=0; i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS, MODE_HISTORY)) return(false);
      
      if(OrderType() > OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != magic ) continue; //not my order
      
      datetime time1 = OrderCloseTime();
      datetime time2 = TimeCurrent();

      if(TimeYear(time1) == TimeYear(time2) && TimeMonth(time1) == TimeMonth(time2) && TimeDay(time1) == TimeDay(time2))
      {     
         if(NormalizeDouble(OrderProfit() + OrderSwap() + OrderCommission(),2) > 0.0) pos_plus++;
         else pos_minus++;
      }
   }

   if(TRADE_STOP_PLUS>0 && pos_plus - pos_minus >= TRADE_STOP_PLUS)  trade = false;
   if(TRADE_STOP_MINUS>0 && pos_minus - pos_plus >= TRADE_STOP_MINUS) trade = false;
   //Print(pos_plus," ",pos_minus);
   return(true);
}



